import { TSDateForm } from "./tsdatecomp";
import { int, uint, email, url, UUID, isodate, Address, AnyDictionary, Nullable } from "./types";
import { TSData } from "./tsdata";
import { TSDate } from "./tsdate";
export declare function $defined(o: any): boolean;
export declare function $ok(o: any): boolean;
export declare function $value<T>(o: Nullable<T>, v: T): T;
export declare function $valueornull<T>(o: Nullable<T>): T | null;
export declare function $valueorundefine<T>(o: Nullable<T>): T | undefined;
export declare function $isstring(o: any): boolean;
export declare function $iswhitespace(c: Nullable<string>): boolean;
export declare function $isnumber(o: any): boolean;
export declare function $isint(o: any): boolean;
export declare function $isunsigned(o: any, maximum?: number): boolean;
export declare function $isbool(o: any): boolean;
export declare function $isobject(o: any): boolean;
export declare function $objectcount(o: any): number;
export declare function $isarray(o: any): boolean;
export declare function $isiterable(o: any): boolean;
export declare function $isdate(o: any): boolean;
export declare function $isemail(o: any): boolean;
export declare function $isurl(o: any, opts?: $urlOptions): boolean;
export declare function $isuuid(o: any): boolean;
export declare function $isfunction(o: any): boolean;
export declare function $intornull(n: Nullable<string | number>): int | null;
export declare function $int(n: Nullable<string | number>, defaultValue?: int): int;
export declare function $email(s: Nullable<string>): email | null;
export interface $urlOptions {
    acceptsProtocolRelativeUrl?: boolean;
    acceptedProtocols?: string[];
}
export declare function $url(s: Nullable<string>, opts?: $urlOptions): url | null;
export declare function $UUID(s: Nullable<string>): UUID | null;
export declare type IsoDateFormat = TSDateForm.ISO8601C | TSDateForm.ISO8601L | TSDateForm.ISO8601;
export declare function $isodate(s: Nullable<Date | TSDate | string>, format?: IsoDateFormat): isodate | null;
export declare function $address(a: Nullable<Address>): Address | null;
export declare function $unsignedornull(n: Nullable<string | number>): uint | null;
export declare function $unsigned(v: Nullable<string | number>, defaultValue?: uint): uint;
export declare function $toint(v: Nullable<string | number>, defaultValue?: int): int;
export declare function $tounsigned(v: Nullable<string | number>, defaultValue?: uint): uint;
export declare function $div(a: number, b: number): number;
export declare function $string(v: any): string;
export declare function $strings(v: Nullable<string[] | string>): string[];
export declare function $totype<T>(v: any): T | null;
/**
 *   We don't use standard trim because it does not trim all unicode whitespaces!
 */
export declare function $ltrim(s: Nullable<string>): string;
export declare function $rtrim(s: Nullable<string>): string;
export declare function $ftrim(s: Nullable<string>): string;
export { $ftrim as $trim };
export declare function $lines(s: Nullable<string>): string[];
export declare function $normspaces(s: Nullable<string>): string;
export declare function $firstcap(s: Nullable<string>): string;
export declare function $capitalize(s: Nullable<string>): string;
export declare function $fpad2(v: number, failedChar?: string): string;
export declare function $fpad3(v: number, failedChar?: string): string;
export declare function $fpad4(v: number, failedChar?: string): string;
export declare function $fpad(v: number, pad: number, failedChar?: string): string;
export declare function $ascii(source: Nullable<string>): string;
export declare function $capacityForCount(count: uint): uint;
export declare function $count<T = any>(a: Nullable<ArrayLike<T>>): number;
export declare function $length(s: Nullable<string | Uint8Array | TSData>): number;
export declare function $lengthin(s: Nullable<string | Uint8Array | TSData>, min?: number, max?: number): boolean;
export interface $unitOptions {
    unitName?: string;
    unit?: string;
    minimalUnit?: number;
    maximalUnit?: number;
    decimals?: number;
    ignoreZeroDecimals?: boolean;
    ignoreMinimalUnitDecimals?: boolean;
}
export declare function $unit(n: Nullable<number>, opts?: $unitOptions): string;
export declare function $octets(n: Nullable<number>, decimals?: number): string;
export declare function $meters(n: Nullable<number>, decimals?: number): string;
export declare function $map<T, R = T>(values: Nullable<Iterable<T>>, callback: (value: T, index: number) => Nullable<R>): R[];
export declare function $first<T = any>(values: Nullable<ArrayLike<T>>): T | undefined;
export declare function $last<T = any>(values: Nullable<ArrayLike<T>>): T | undefined;
export declare function $sum<T = any>(values: Nullable<Iterable<T>>): number | undefined;
export interface $averageOptions {
    countsOnlyOKItems?: boolean;
    countsOnlyDefinedItems?: boolean;
}
export declare function $average<T = any>(values: Nullable<Iterable<T>>, opts?: $averageOptions): number | undefined;
export declare function $jsonobj(v: any): any;
export declare function $keys<T>(o: Nullable<T>): Array<keyof T>;
export interface $partialOptions<T, U> {
    properties?: Array<keyof T | keyof U>;
    filter?: (v: T[keyof T]) => T[keyof T] | U[keyof U] | undefined;
}
export declare function $partial<T, U>(a: Nullable<T>, opts?: $partialOptions<T, U>): [U, number];
export declare function $dict<T = object>(source: Nullable<T>, keys?: Array<keyof T>): AnyDictionary;
export declare function $includesdict(source: Nullable<object>, dict: AnyDictionary, keys?: string[]): boolean;
export interface $fusionOptions<T, U> {
    A?: $partialOptions<T, U>;
    B?: $partialOptions<T, U>;
    fusionArrays?: (a: Array<any>, b: Array<any>) => Array<any>;
    fusionObjects?: (a: object, b: object) => object;
}
export declare function $fusion<T, U>(a: Nullable<T>, b: Nullable<U>, opts?: $fusionOptions<T, U>): [Partial<T> & Partial<U>, number];
export declare function $json(v: any, replacer?: (number | string)[] | null, space?: string | number): string;
declare global {
    export interface Array<T> {
        first: () => T | undefined;
        last: () => T | undefined;
        sum: () => number | undefined;
        average: (opts?: $averageOptions) => number | undefined;
        filteredMap: <R = T>(callback: (value: T, index: number) => Nullable<R>) => R[];
    }
    export interface String {
        ascii: (this: string) => string;
        firstCap: (this: string) => string;
        capitalize: (this: string) => string;
        normalizeSpaces: (this: string) => string;
        ftrim: (this: string) => string;
        ltrim: (this: string) => string;
        rtrim: (this: string) => string;
        isDate: (this: string) => boolean;
        isEmail: (this: string) => boolean;
        isUrl: (this: string) => boolean;
        isUUID: (this: string) => boolean;
        lines: (this: string) => string[];
    }
    export interface Number {
        unit: (this: number, opts?: $unitOptions) => string;
        meters: (this: number, decimals?: number) => string;
        octets: (this: number, decimals?: number) => string;
        fpad: (this: number, pad: number, failedChar?: string) => string;
        fpad2: (this: number, failedChar?: string) => string;
        fpad3: (this: number, failedChar?: string) => string;
        fpad4: (this: number, failedChar?: string) => string;
        toInt: (this: number, defaultValue?: int) => int;
        toUnsigned: (this: number, defaultValue?: uint) => uint;
    }
}
