"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.$count = exports.$capacityForCount = exports.$ascii = exports.$fpad = exports.$fpad4 = exports.$fpad3 = exports.$fpad2 = exports.$capitalize = exports.$firstcap = exports.$normspaces = exports.$lines = exports.$trim = exports.$ftrim = exports.$rtrim = exports.$ltrim = exports.$totype = exports.$strings = exports.$string = exports.$div = exports.$tounsigned = exports.$toint = exports.$unsigned = exports.$unsignedornull = exports.$address = exports.$isodate = exports.$UUID = exports.$url = exports.$email = exports.$int = exports.$intornull = exports.$isfunction = exports.$isuuid = exports.$isurl = exports.$isemail = exports.$isdate = exports.$isiterable = exports.$isarray = exports.$objectcount = exports.$isobject = exports.$isbool = exports.$isunsigned = exports.$isint = exports.$isnumber = exports.$iswhitespace = exports.$isstring = exports.$valueorundefine = exports.$valueornull = exports.$value = exports.$ok = exports.$defined = void 0;
exports.$json = exports.$fusion = exports.$includesdict = exports.$dict = exports.$partial = exports.$keys = exports.$jsonobj = exports.$average = exports.$sum = exports.$last = exports.$first = exports.$map = exports.$meters = exports.$octets = exports.$unit = exports.$lengthin = exports.$length = void 0;
const compare_1 = require("./compare");
const string_tables_1 = require("./string_tables");
const tsdatecomp_1 = require("./tsdatecomp");
const tsdefaults_1 = require("./tsdefaults");
const types_1 = require("./types");
const tsdate_1 = require("./tsdate");
function $defined(o) { return o !== undefined && typeof o !== 'undefined'; }
exports.$defined = $defined;
function $ok(o) { return o !== null && o !== undefined && typeof o !== 'undefined'; }
exports.$ok = $ok;
function $value(o, v) { return $ok(o) ? o : v; }
exports.$value = $value;
function $valueornull(o) { return $ok(o) ? o : null; }
exports.$valueornull = $valueornull;
function $valueorundefine(o) { return $ok(o) ? o : undefined; }
exports.$valueorundefine = $valueorundefine;
function $isstring(o) { return o !== null && o !== undefined && typeof o === 'string'; }
exports.$isstring = $isstring;
function $iswhitespace(c) { return $length(c) >= 1 && string_tables_1.FoundationWhiteSpaces.includes(c.charAt(0)); }
exports.$iswhitespace = $iswhitespace;
function $isnumber(o) { return o !== null && o !== undefined && typeof o === 'number' && !isNaN(o) && isFinite(o); }
exports.$isnumber = $isnumber;
function $isint(o) { return o !== null && o !== undefined && typeof o === 'number' && Number.isSafeInteger(o) && o >= types_1.INT_MIN && o <= types_1.INT_MAX; }
exports.$isint = $isint;
function $isunsigned(o, maximum = types_1.UINT_MAX) { return o !== null && o !== undefined && typeof o === 'number' && Number.isSafeInteger(o) && o >= 0 && o <= maximum; }
exports.$isunsigned = $isunsigned;
function $isbool(o) { return o !== null && o !== undefined && typeof o === 'boolean'; }
exports.$isbool = $isbool;
function $isobject(o) { return o !== null && o !== undefined && typeof o === 'object'; }
exports.$isobject = $isobject;
function $objectcount(o) { return $isobject(o) ? $keys(o).length : 0; }
exports.$objectcount = $objectcount;
function $isarray(o) { return Array.isArray(o); }
exports.$isarray = $isarray;
function $isiterable(o) { return $isarray(o) || ($ok(o) && $isfunction(o[Symbol.iterator])); }
exports.$isiterable = $isiterable;
function $isdate(o) { return (o instanceof Date || o instanceof tsdate_1.TSDate || $isstring(o)) && $ok($isodate(o)); }
exports.$isdate = $isdate;
function $isemail(o) { return $isstring(o) && $ok($email(o)); }
exports.$isemail = $isemail;
function $isurl(o, opts) { return o instanceof URL || ($isstring(o) && $ok($url(o, opts))); }
exports.$isurl = $isurl;
function $isuuid(o) { return $isstring(o) && $ok($UUID(o)); }
exports.$isuuid = $isuuid;
function $isfunction(o) { return typeof o === 'function'; }
exports.$isfunction = $isfunction;
function $intornull(n) {
    if (!$ok(n)) {
        return null;
    }
    if (typeof n === 'string') {
        n = parseInt(n, 10);
    }
    return $isint(n) ? n : null;
}
exports.$intornull = $intornull;
function $int(n, defaultValue = 0) {
    n = $intornull(n);
    return $ok(n) ? n : defaultValue;
}
exports.$int = $int;
function $email(s) {
    const m = _regexvalidatedstring(types_1.emailRegex, s);
    return $ok(m) ? m.toLowerCase() : null;
}
exports.$email = $email;
function $url(s, opts = {}) {
    if (!$length(s)) {
        return null;
    }
    const m = s.match(types_1.urlRegex);
    if ((m === null || m === void 0 ? void 0 : m.length) !== 2) {
        return null;
    }
    if ($ok(m[1])) {
        const protocol = m[1].toLowerCase();
        if (!protocol.length) {
            return null;
        }
        if ($count(opts.acceptedProtocols)) {
            return $ok(opts.acceptedProtocols.find(v => v.toLowerCase() === protocol)) ? s : null;
        }
        return protocol === 'http' || protocol === 'https' ? s : null;
    }
    return m[1] !== null && opts.acceptsProtocolRelativeUrl ? s : null;
}
exports.$url = $url;
function $UUID(s) {
    if (!$isstring(s)) {
        return null;
    }
    return _regexvalidatedstring(types_1.uuidRegex, s);
}
exports.$UUID = $UUID;
function $isodate(s, format = tsdatecomp_1.TSDateForm.ISO8601) {
    let cps = null;
    if ($ok(s)) {
        if (s instanceof Date) {
            cps = (0, tsdatecomp_1.$components)(s);
        }
        else if (s instanceof tsdate_1.TSDate) {
            cps = s.toComponents();
        }
        else if ($isstring(s)) {
            cps = (0, tsdatecomp_1.$parsedatetime)($ftrim(s), format);
        } // we parse the string to verify it
    }
    return $ok(cps) ? (0, tsdatecomp_1.$components2string)(cps, format) : null;
}
exports.$isodate = $isodate;
function $address(a) {
    if (!$isobject(a)) {
        return null;
    }
    const city = $ftrim(a === null || a === void 0 ? void 0 : a.city);
    const country = (0, tsdefaults_1.$country)(a === null || a === void 0 ? void 0 : a.country);
    if (!$isstring(city) || !$length(city) || !$ok(country)) {
        return null;
    }
    let ret = Object.assign({}, a);
    ret.city = city;
    ret.country = country;
    return ret;
}
exports.$address = $address;
function $unsignedornull(n) {
    if (!$ok(n)) {
        return null;
    }
    if (typeof n === 'string') {
        n = parseInt(n, 10);
    }
    return $isunsigned(n) ? n : null;
}
exports.$unsignedornull = $unsignedornull;
function $unsigned(v, defaultValue = 0) {
    const n = $unsignedornull(v);
    return $ok(n) ? n : defaultValue;
}
exports.$unsigned = $unsigned;
function $toint(v, defaultValue = 0) {
    if (!$ok(v)) {
        return defaultValue;
    }
    if (typeof v === 'string') {
        v = parseInt(v, 10);
    }
    return isNaN(v) ? defaultValue : Math.max(types_1.INT_MIN, _icast(Math.min(v, types_1.INT_MAX)));
}
exports.$toint = $toint;
function $tounsigned(v, defaultValue = 0) {
    if (!$ok(v)) {
        return defaultValue;
    }
    if (typeof v === 'string') {
        v = parseInt(v, 10);
    }
    return isNaN(v) ? defaultValue : Math.max(types_1.UINT_MIN, _icast(Math.min(v, types_1.UINT_MAX)));
}
exports.$tounsigned = $tounsigned;
function $div(a, b) { return _icast(a / b); }
exports.$div = $div;
function $string(v) {
    if (!$ok(v))
        return '';
    return typeof v === 'object' && 'toString' in v ? v.toString() : `${v}`;
}
exports.$string = $string;
function $strings(v) { return $ok(v) ? ($isarray(v) ? v : [v]) : []; }
exports.$strings = $strings;
function $totype(v) { return $ok(v) ? v : null; }
exports.$totype = $totype;
/**
 *   We don't use standard trim because it does not trim all unicode whitespaces!
 */
// left-trim
function $ltrim(s) { return $length(s) ? s.replace(string_tables_1.FoundationLeftTrimRegex, "") : ''; }
exports.$ltrim = $ltrim;
// right-trim
function $rtrim(s) { return $length(s) ? s.replace(string_tables_1.FoundationRightTrimRegex, "") : ''; }
exports.$rtrim = $rtrim;
// full-trim
function $ftrim(s) { return $length(s) ? s.replace(string_tables_1.FoundationLeftTrimRegex, "").replace(string_tables_1.FoundationRightTrimRegex, "") : ''; }
exports.$ftrim = $ftrim;
exports.$trim = $ftrim;
function $lines(s) { return $ok(s) ? s.split(/[\n\f\r\u000B]/) : []; }
exports.$lines = $lines;
function $normspaces(s) { return $ftrim(s).replace(string_tables_1.FoundationFindAllWhitespacesRegex, " "); }
exports.$normspaces = $normspaces;
function $firstcap(s) { return _capitalize(s, 1); }
exports.$firstcap = $firstcap;
function $capitalize(s) { return _capitalize(s); }
exports.$capitalize = $capitalize;
function $fpad2(v, failedChar) { return $fpad(v, 2, failedChar); }
exports.$fpad2 = $fpad2;
function $fpad3(v, failedChar) { return $fpad(v, 3, failedChar); }
exports.$fpad3 = $fpad3;
function $fpad4(v, failedChar) { return $fpad(v, 4, failedChar); }
exports.$fpad4 = $fpad4;
function $fpad(v, pad, failedChar) {
    const isUnsigned = $isunsigned(v);
    return (isUnsigned ? v.toString() : '').padStart(pad, isUnsigned ? '0' : $length(failedChar) === 1 ? failedChar : 'X');
}
exports.$fpad = $fpad;
// for now $ascii() does not mak any transliterations from
// non-latin languages like Greek
function $ascii(source) {
    const l = $length(source);
    if (!l)
        return '';
    let s = source.replace(/≠/g, "");
    s = s.normalize("NFD").replace(/[\u0300-\u036f]|\u00a8|\u00b4/g, "").normalize("NFKD"); // does most of the job
    // finally we will try to convert (or remove) the remaining non ascii characters
    return s.replace(/[^\x00-\x7F]/g, x => string_tables_1.FoundationASCIIConversion[x] || '');
}
exports.$ascii = $ascii;
function $capacityForCount(count) { return (count < 128 ? __capacitiesForCounts[count] : ((count + (count >> 1)) & ~255) + 256); }
exports.$capacityForCount = $capacityForCount;
function $count(a) { return $ok(a) ? a.length : 0; }
exports.$count = $count;
function $length(s) { return $ok(s) ? s.length : 0; }
exports.$length = $length;
function $lengthin(s, min = 0, max = types_1.INT_MAX) { const l = $length(s); return l >= min && l <= max; }
exports.$lengthin = $lengthin;
const TSUnitMultiples = ['y', 'z', 'a', 'f', 'p', 'n', 'µ', 'm', '', 'k', 'M', 'G', 'T', 'P', 'E', 'Z', 'Y'];
const TSLog1000 = Math.log(1000);
// default unit is m (for meters)
function $unit(n, opts = {}) {
    const v = $ok(n) ? n : 0;
    const sn = $ftrim(opts.unitName);
    const su = $ftrim(opts.unit);
    const unitName = sn.length ? sn : (su.length ? su : 'm');
    const minU = $ok(opts.minimalUnit) ? Math.min(0, Math.max(-8, opts.minimalUnit)) : -8;
    const maxU = $ok(opts.maximalUnit) ? Math.min(8, Math.max(0, opts.maximalUnit)) : 8;
    let dm = $isunsigned(opts.decimals) ? opts.decimals : 2;
    if (v === 0) {
        if (dm === 0 || opts.ignoreZeroDecimals || (minU === 0 && opts.ignoreMinimalUnitDecimals)) {
            return '0 ' + unitName;
        }
        return '0.'.padEnd(2 + dm, '0') + ' ' + unitName;
    }
    const unit = su.length ? su : unitName.charAt(0);
    const i = Math.max(minU, Math.min(maxU, Math.floor(Math.log(Math.abs(v)) / TSLog1000)));
    if (i === minU && opts.ignoreMinimalUnitDecimals) {
        dm = 0;
    }
    return ((0.0 + v) / (0.0 + Math.pow(1000, i))).toFixed(dm) + ' ' + TSUnitMultiples[i + 8] + (i == 0 ? unitName : unit);
}
exports.$unit = $unit;
function $octets(n, decimals = 2) {
    return $unit(n, {
        decimals: decimals,
        unit: 'o',
        unitName: 'octets',
        minimalUnit: 0,
        ignoreZeroDecimals: true,
        ignoreMinimalUnitDecimals: true
    });
}
exports.$octets = $octets;
function $meters(n, decimals = 2) {
    return $unit(n, { decimals: decimals });
}
exports.$meters = $meters;
/*
    This is a map function where callback returns as null or undefined are
    flushed from the result
 */
function $map(values, callback) {
    const ret = new Array();
    if ($ok(values)) {
        let index = 0;
        for (let v of values) {
            const mv = callback(v, index);
            if ($ok(mv)) {
                ret.push(mv);
            }
            index++;
        }
    }
    return ret;
}
exports.$map = $map;
function $first(values) {
    const n = $count(values);
    return n > 0 ? values[0] : undefined;
}
exports.$first = $first;
function $last(values) {
    const n = $count(values);
    return n > 0 ? values[n - 1] : undefined;
}
exports.$last = $last;
// the sum of null, undefined or an empty array is always 0, 
// regardless of what it could contain
function $sum(values) {
    // with that implementation undefined and null values are considered as 0 for the sum
    const [, , , sum] = _countsAndSum(values);
    return sum;
}
exports.$sum = $sum;
function $average(values, opts = {}) {
    let [count, definedCount, okCount, sum] = _countsAndSum(values);
    if (opts.countsOnlyOKItems) {
        count = okCount;
    }
    else if (opts.countsOnlyDefinedItems) {
        count = definedCount;
    }
    return $defined(sum) && count > 0 ? sum / count : undefined;
}
exports.$average = $average;
function _countsAndSum(values) {
    // since we work on Iterable, we don't use any length
    // and count our collection when trying to perform a sum
    let sum = 0;
    let validCount = 0;
    let definedCount = 0;
    let totalCount = 0;
    if ($ok(values)) {
        for (let v of values) {
            if ($defined(v)) {
                if (v !== null) {
                    if ($defined(sum)) {
                        let n = undefined;
                        if ($isnumber(v)) {
                            n = v;
                        }
                        else if ($isstring(v)) {
                            n = Number(v);
                        }
                        else if ('toNumber' in v) {
                            n = v.toNumber();
                        }
                        if (!$isnumber(n)) {
                            sum = undefined;
                        } // any fails to number conversion definitely invalidates the sum
                        else {
                            sum += n;
                        }
                    }
                    validCount++;
                }
                definedCount++;
            }
            totalCount++;
        }
    }
    return [totalCount, definedCount, validCount, sum];
}
function $jsonobj(v) {
    if (v === null || v === undefined)
        return v;
    const t = typeof v;
    switch (t) {
        case 'object':
            return 'toJSON' in v ? v.toJSON() : v;
        case 'boolean':
        case 'number':
        case 'bigint':
        case 'string':
            return v;
        default:
            return undefined;
    }
}
exports.$jsonobj = $jsonobj;
function $keys(o) { return $ok(o) ? Object.getOwnPropertyNames(o) : []; }
exports.$keys = $keys;
// default filter supress undefined, null values and functions (methods for real class instances)
// if properties is not set, we use all the object keys to apply the filter
function $partial(a, opts = {}) {
    let ret = {};
    let n = 0;
    if ($ok(a)) {
        n = _fillObject('partial', ret, a, opts);
    }
    return [ret, n];
}
exports.$partial = $partial;
// TODO: review all AnyDictionary functions to make a specific file 
// and a more thorough specificaiton. Here, all null, undefined and function
// properties are removed
function $dict(source, keys) {
    const ret = {};
    if ($ok(source)) {
        _fillObject('dict', ret, source, { properties: keys });
    }
    return ret;
}
exports.$dict = $dict;
function $includesdict(source, dict, keys) {
    if ($ok(source)) {
        keys = $ok(keys) ? keys : $keys(dict);
        if (keys.length) {
            const v = source;
            for (let k of keys) {
                if (!(0, compare_1.$equal)(v[k], dict[k])) {
                    return false;
                }
            }
            return true;
        }
    }
    return false;
}
exports.$includesdict = $includesdict;
function $fusion(a, b, opts = {}) {
    if (!$ok(a)) {
        return $ok(b) ? $partial(b, opts.B) : [{}, 0];
    }
    else if (!$ok(b)) {
        return $partial(a, opts.A);
    }
    let [ret, n] = $partial(a, opts.A);
    let fopts = $ok(opts.B) ? Object.assign({}, opts.B) : {};
    if ($ok(opts.fusionArrays)) {
        fopts.fusionArrays = opts.fusionArrays;
    }
    if ($ok(opts.fusionObjects)) {
        fopts.fusionObjects = opts.fusionObjects;
    }
    n += _fillObject('fusion', ret, b, fopts);
    return [ret, n];
}
exports.$fusion = $fusion;
function $json(v, replacer = null, space = 2) { return JSON.stringify(v, replacer, space); }
exports.$json = $json;
// ===== private functions ===================================
function _regexvalidatedstring(regex, s) {
    const v = $ftrim(s);
    if (!v.length || !regex.test(v)) {
        return null;
    }
    return v;
}
function _fillObject(fn, destination, source, opts = {}) {
    let ret = 0;
    opts = Object.assign({}, opts);
    opts.properties = $ok(opts.properties) ? opts.properties : $keys(source);
    if (opts.properties.length) {
        const fusion_arrays = $isfunction(opts.fusionArrays);
        const fusion_objects = $isfunction(opts.fusionObjects);
        opts.filter = $isfunction(opts.filter) ? opts.filter : (v) => $ok(v) && typeof v !== 'function' ? v : undefined;
        for (let p of opts.properties) {
            if (!$isstring(p)) {
                throw `${fn}() needs to have valid string properties`;
            }
            const v = opts.filter(source[p]);
            if ($defined(v)) {
                if (fusion_arrays && $isarray(v) && $isarray(destination[p])) {
                    destination[p] = opts.fusionArrays(destination[p], v);
                }
                else if (fusion_objects && $isobject(v) && $isobject(destination[p])) {
                    destination[p] = opts.fusionObjects(destination[p], v);
                }
                else {
                    destination[p] = v;
                }
                ret++;
            }
        }
    }
    return ret;
}
const __capacitiesForCounts = [
    /* 000 */ 2, 2, 4, 4, 8, 8, 8, 8,
    /* 008 */ 16, 16, 16, 16, 16, 16, 16, 16,
    /* 016 */ 32, 32, 32, 32, 32, 32, 32, 32,
    /* 024 */ 32, 32, 32, 32, 32, 32, 32, 32,
    /* 032 */ 64, 64, 64, 64, 64, 64, 64, 64,
    /* 040 */ 64, 64, 64, 64, 64, 64, 64, 64,
    /* 048 */ 64, 64, 64, 64, 64, 64, 64, 64,
    /* 056 */ 128, 128, 128, 128, 128, 128, 128, 128,
    /* 064 */ 128, 128, 128, 128, 128, 128, 128, 128,
    /* 072 */ 128, 128, 128, 128, 128, 128, 128, 128,
    /* 080 */ 128, 128, 128, 128, 128, 128, 128, 128,
    /* 088 */ 128, 128, 128, 128, 128, 128, 128, 128,
    /* 096 */ 128, 128, 128, 128, 128, 128, 128, 128,
    /* 104 */ 256, 256, 256, 256, 256, 256, 256, 256,
    /* 112 */ 256, 256, 256, 256, 256, 256, 256, 256,
    /* 120 */ 256, 256, 256, 256, 256, 256, 256, 256
];
if (!('fpad' in Number.prototype)) {
    Number.prototype.unit = function unit(opts) { return $unit(this, opts); };
    Number.prototype.meters = function meters(decimals) { return $meters(this, decimals); };
    Number.prototype.octets = function octets(decimals) { return $octets(this, decimals); };
    Number.prototype.fpad = function fpad(pad, failedChar) { return $fpad(this, pad, failedChar); };
    Number.prototype.fpad2 = function fpad(failedChar) { return $fpad(this, 2, failedChar); };
    Number.prototype.fpad3 = function fpad(failedChar) { return $fpad(this, 3, failedChar); };
    Number.prototype.fpad4 = function fpad(failedChar) { return $fpad(this, 4, failedChar); };
}
if (!('toInt' in Number.prototype)) {
    Number.prototype.toInt = function toInt(defaultValue) { return $toint(this, defaultValue); };
}
if (!('toUnsigned' in Number.prototype)) {
    Number.prototype.toUnsigned = function toUnsigned(defaultValue) { return $tounsigned(this, defaultValue); };
}
if (!('ascii' in String.prototype)) {
    String.prototype.ascii = function ascii() { return $ascii(this); };
}
if (!('firstCap' in String.prototype)) {
    String.prototype.firstCap = function firstCap() { return $firstcap(this); };
}
if (!('capitalize' in String.prototype)) {
    String.prototype.capitalize = function capitalize() { return $capitalize(this); };
}
if (!('normalizeSpaces' in String.prototype)) {
    String.prototype.normalizeSpaces = function normalizeSpaces() { return $normspaces(this); };
}
if (!('ftrim' in String.prototype)) {
    String.prototype.ftrim = function ftrim() { return $ftrim(this); };
}
if (!('ltrim' in String.prototype)) {
    String.prototype.ltrim = function ltrim() { return $ltrim(this); };
}
if (!('rtrim' in String.prototype)) {
    String.prototype.rtrim = function rtrim() { return $rtrim(this); };
}
if (!('isDate' in String.prototype)) {
    String.prototype.isDate = function isDate() { return $ok($isodate(this)); };
}
if (!('isEmail' in String.prototype)) {
    String.prototype.isEmail = function isEmail() { return $ok($email(this)); };
}
if (!('isUrl' in String.prototype)) {
    String.prototype.isUrl = function isUrl() { return $ok($url(this)); };
}
if (!('isUUID' in String.prototype)) {
    String.prototype.isUUID = function isUUID() { return $ok($UUID(this)); };
}
if (!('lines' in String.prototype)) {
    String.prototype.lines = function lines() { return $lines(this); };
}
if (!('first' in Array.prototype)) {
    Array.prototype.first = function first() { return $first(this); };
}
if (!('last' in Array.prototype)) {
    Array.prototype.last = function first() { return $last(this); };
}
if (!('sum' in Array.prototype)) {
    Array.prototype.sum = function sum() { return $sum(this); };
}
if (!('average' in Array.prototype)) {
    Array.prototype.average = function average(opts) { return $average(this, opts); };
}
if (!('filteredMap' in Array.prototype)) {
    Array.prototype.filteredMap = function filteredMap(callback) { return $map(this, callback); };
}
function _icast(v) {
    return v >= 0 ? (v <= types_1.UINT32_MAX ? v | 0 : Math.floor(v)) : (v >= types_1.INT32_MIN ? -((-v) | 0) : -Math.floor(-v));
}
function _capitalize(s, max = 0) {
    const len = $length(s);
    let ret = "";
    if (!max) {
        max = len;
    }
    ;
    let lastCharWasNotLetter = true;
    let n = 0;
    for (let i = 0; i < len; i++) {
        const c = s.charAt(i);
        const isLetter = _charAssimilableAsLetter(c);
        if (isLetter && lastCharWasNotLetter && n < max) {
            ret += c.toUpperCase();
            n++;
        }
        else {
            ret += c;
        }
        lastCharWasNotLetter = !isLetter;
    }
    return ret;
}
function _charAssimilableAsLetter(c) {
    c = $ascii(c);
    if (c.length) {
        const v = c.charCodeAt(0) & ~32;
        return v >= 65 && v <= 90;
    }
    return false;
}
//# sourceMappingURL=commons.js.map