"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.$password = exports.$random = exports.$hashfile = exports.$hash = exports.$decrypt = exports.$encrypt = exports.HashMethod = exports.$uuid = void 0;
const crypto = __importStar(require("crypto"));
const fs_1 = require("fs");
const commons_1 = require("./commons");
function $uuid() {
    try {
        return crypto.randomUUID();
    }
    catch (_a) {
        console.log('Warning:crypto.randomUUID() is not available');
        let uuid = "";
        for (let i = 0; i < 32; i++) {
            const rand = Math.random() * 16 | 0;
            if (i == 8 || i == 12 || i == 16 || i == 20) {
                uuid += '-';
            }
            uuid += (i == 12 ? 4 : (i == 16 ? (rand & 3 | 8) : rand)).toString(16);
        }
        return uuid;
    }
}
exports.$uuid = $uuid;
var HashMethod;
(function (HashMethod) {
    HashMethod["SHA256"] = "SHA256";
    HashMethod["SHA384"] = "SHA384";
    HashMethod["SHA512"] = "SHA512";
})(HashMethod = exports.HashMethod || (exports.HashMethod = {}));
function $encrypt(source, key) {
    if ((0, commons_1.$length)(key) !== 32 || !(0, commons_1.$length)(source)) {
        return null;
    }
    let returnValue;
    try {
        let iv = crypto.randomBytes(16);
        let cipher = crypto.createCipheriv('aes-256-cbc', Buffer.from(key), iv);
        let encrypted = cipher.update(source);
        encrypted = Buffer.concat([encrypted, cipher.final()]);
        returnValue = iv.toString('hex') + encrypted.toString('hex');
    }
    catch (e) {
        returnValue = null;
    }
    return returnValue;
}
exports.$encrypt = $encrypt;
function $decrypt(source, key) {
    if ((0, commons_1.$length)(key) !== 32 || (0, commons_1.$length)(source) < 32) {
        return null;
    }
    let returnValue;
    try {
        let iv = Buffer.from(source.slice(0, 32), 'hex');
        let encryptedText = Buffer.from(source.slice(32), 'hex');
        let decipher = crypto.createDecipheriv('aes-256-cbc', Buffer.from(key), iv);
        let decrypted = decipher.update(encryptedText);
        decrypted = Buffer.concat([decrypted, decipher.final()]);
        returnValue = decrypted.toString();
    }
    catch (e) {
        returnValue = null;
    }
    return returnValue;
}
exports.$decrypt = $decrypt;
function $hash(buf, method) {
    let ret = null;
    try {
        let hash = crypto.createHash((0, commons_1.$length)(method) ? method.toLowerCase() : 'sha256');
        hash.update(buf);
        ret = hash.digest('hex');
    }
    catch (e) {
        ret = null;
    }
    return ret;
}
exports.$hash = $hash;
function $hashfile(filePath, method) {
    return __awaiter(this, void 0, void 0, function* () {
        return new Promise((resolve, reject) => {
            let hash = crypto.createHash((0, commons_1.$length)(method) ? method.toLowerCase() : 'sha256');
            if (!(0, commons_1.$length)(filePath)) {
                return reject(null);
            }
            try {
                (0, fs_1.createReadStream)(filePath).on('data', data => hash.update(data)).on('end', () => resolve(hash.digest('hex')));
            }
            catch (e) {
                return reject(null);
            }
        });
    });
}
exports.$hashfile = $hashfile;
;
// TODO a better random generator
function $random(max) {
    return Math.floor(Math.random() * Math.floor(max));
}
exports.$random = $random;
function $password(len, opts = { hasLowercase: true }) {
    const MAX_CONSECUTIVE_CHARS = 2;
    if (!opts.hasLowercase && !opts.hasNumeric && !opts.hasSpecials && !opts.hasUppercase) {
        opts.hasUppercase = true;
    }
    if (len < 3 || len > 256)
        return null;
    let base = '';
    if (opts.hasLowercase) {
        base = base + "abcdefghijklmnopqrstuvwxyz";
    }
    if (opts.hasUppercase) {
        base = base + "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
    }
    if (opts.hasNumeric) {
        base = base + "0123456789";
    }
    if (opts.hasLowercase && ($random(891) % 7)) {
        base = base + "abcdefghijklmnopqrstuvwxyz";
    }
    if (opts.hasLowercase) {
        base = base + "abcdefghijklmnopqrstuvwxyz";
    }
    if (opts.hasSpecials) {
        base = base + "!#$-_&*@()+/";
    }
    if (opts.hasSpecials && ($random(1795) % 3)) {
        base = base + "-#@*!";
    }
    if (opts.hasNumeric && ($random(733) % 2)) {
        base = base + "0123456789";
    }
    if (opts.hasNumeric) {
        base = base + "0123456789";
    }
    if (opts.hasLowercase) {
        base = base + "abcdefghijklmnopqrstuvwxyz";
    }
    const charlen = base.length;
    let identicals = 0, i = 0;
    let last = '', password = '';
    while (i < len) {
        let c = base.charAt($random(charlen));
        if (c == last) {
            if (++identicals == MAX_CONSECUTIVE_CHARS) {
                identicals--;
            }
            else {
                password = password + c;
                i++;
            }
            ;
        }
        else {
            last = c;
            identicals = 0;
            password = password + c;
            i++;
        }
    }
    return password;
}
exports.$password = $password;
//# sourceMappingURL=crypto.js.map