/**
 * 	All File System operations are maint to be in this file
 *  This means that no import of 'fs' module shouls apear elsewere
 *
 *  We also tries to use sync functions in order not to publish async functions
 *  for those basic stiff. It could be changed at any moment
 *  by using fs.promises...
 */
/// <reference types="node" />
/// <reference types="node" />
import { Stats } from 'fs';
import { TSData } from './tsdata';
import { Nullable } from './types';
export declare function $stats(src: Nullable<string>): Nullable<Stats>;
export declare function $isfile(src: Nullable<string>): boolean;
export declare function $isexecutable(src: Nullable<string>): boolean;
export declare function $isreadable(src: Nullable<string>): boolean;
export declare function $chmod(src: Nullable<string>, mode: number): boolean;
export declare function $iswritable(src: Nullable<string>): boolean;
export declare function $isdirectory(src: Nullable<string>): boolean;
export declare function $createDirectory(p: Nullable<string>): boolean;
export declare function $filesize(src: Nullable<string>): number;
export declare function $temporarypath(ext?: Nullable<string>, src?: Nullable<string>): string;
export declare function $uniquefile(src?: Nullable<string>, e?: Nullable<string>, internalImplementation?: boolean): string;
export declare function $isabsolutepath(src?: Nullable<string>, internalImplementation?: boolean): boolean;
export declare function $normalizepath(src?: Nullable<string>, internalImplementation?: boolean): string;
export declare function $path(first: string | boolean, ...paths: string[]): string;
export declare function $ext(s: Nullable<string>, internalImplementation?: boolean): string;
export declare function $withoutext(s: Nullable<string>, internalImplementation?: boolean): string;
export declare function $newext(s: Nullable<string>, e?: Nullable<string>, internalImplementation?: boolean): string;
export declare function $dir(s: Nullable<string>, internalImplementation?: boolean): string;
export declare function $filename(s: Nullable<string>, internalImplementation?: boolean): string;
export declare function $loadJSON(src: Nullable<string | Buffer>): any | null;
export declare function $readString(src: Nullable<string>, encoding?: BufferEncoding): string | null;
export interface BasicWriteOptions {
    attomically?: boolean;
    removePrecedentVersion?: boolean;
}
export interface $writeStringOptions extends BasicWriteOptions {
    encoding?: BufferEncoding;
}
export declare function $writeString(src: Nullable<string>, str: string, opts?: $writeStringOptions): boolean;
export declare function $fullWriteString(src: Nullable<string>, str: string, opts: $writeStringOptions): [boolean, string | null];
export declare function $readBuffer(src: Nullable<string>): Buffer | null;
export declare function $readData(src: Nullable<string>): TSData | null;
export interface $writeBufferOptions extends BasicWriteOptions {
    byteStart?: number;
    byteEnd?: number;
}
export declare function $writeBuffer(src: Nullable<string>, buf: TSData | NodeJS.ArrayBufferView, opts?: $writeBufferOptions): boolean;
export declare function $fullWriteBuffer(src: Nullable<string>, buf: TSData | NodeJS.ArrayBufferView, opts: $writeBufferOptions): [boolean, string | null];
export declare function $localRenameFile(src: Nullable<string>, dest: Nullable<string>): boolean;
export declare function $removeFile(src: Nullable<string>): boolean;
export declare function $realMoveFile(src: Nullable<string>, dest: Nullable<string>): boolean;
export declare function $copyFile(src: Nullable<string>, dest: Nullable<string>, overwrite?: boolean): boolean;
