import { Locales } from './tsdefaults';
import { TSClone, TSObject } from './tsobject';
import { Comparison, country, currency, language, Nullable, StringTranslation } from './types';
/**
 *  WARNING ABOUT countries.json
 *  - Ireland has no localeLanguage : our EULocale is used
 *    instead en language to match a better date format conformance
 *  - There's no US country there since the managed countries are
 *    maint to be the european ones. It may evolve in time.
 */
export declare class TSCountry implements TSObject, TSClone<TSCountry> {
    private static __countriesMap;
    private static __countries;
    private static __EULocale;
    readonly alpha2Code: country;
    readonly alpha3Code: string;
    readonly names: StringTranslation;
    readonly spokenLanguages: language[];
    readonly domains: string[];
    readonly EEC: boolean;
    readonly dialCode: string;
    readonly currency: currency;
    readonly locales: Locales;
    private constructor();
    static loadCountries(localesMap: Map<string, Locales>, managedLanguages: language[]): void;
    static country(c: Nullable<country | string>): TSCountry | null;
    static countries(): TSCountry[];
    get name(): string;
    get language(): language;
    get languageName(): string;
    clone(): TSCountry;
    translatedName(lang?: Nullable<language>): string | null;
    toString(): string;
    toJSON(): any;
    toArray(): string[];
    isEqual(other: any): boolean;
    compare(other: any): Comparison;
}
