"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.TSCouple = void 0;
const commons_1 = require("./commons");
const compare_1 = require("./compare");
const types_1 = require("./types");
/**
 * OK, right, JS Tupples are more flexible than a TSCouple
 * object but, you known, it's still impossible to check
 * if a variable is a tupple or not... so TSCouple is a class
 * and instanceof works.
 */
class TSCouple {
    constructor(first, second) {
        this.first = first;
        this.second = second;
    }
    clone() { return new TSCouple(this.first, this.second); }
    // ============ TSObject conformance =============== 
    isEqual(other) {
        return this === other || (other instanceof TSCouple && (0, compare_1.$equal)(other.first, this.first) && (0, compare_1.$equal)(other.second, this.second));
    }
    compare(other) {
        if (this.isEqual(other)) {
            return types_1.Same;
        }
        else if (other instanceof TSCouple) {
            const c = (0, compare_1.$compare)(this.first, other.first);
            return c === types_1.Same ? (0, compare_1.$compare)(this.second, other.second) : c;
        }
        return undefined;
    }
    toString() { return (0, commons_1.$json)(this); }
    toJSON() { return { first: (0, commons_1.$jsonobj)(this.first), second: (0, commons_1.$jsonobj)(this.second) }; }
    toArray() { return [this.first, this.second]; }
}
exports.TSCouple = TSCouple;
//# sourceMappingURL=tscouple.js.map