"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.TSHttpError = exports.$subclassReponsabililty = exports.TSError = exports.TSUniqueError = void 0;
const commons_1 = require("./commons");
class TSUniqueError extends Error {
    constructor(message) {
        super(message);
    }
    static genericError() {
        if (!(0, commons_1.$ok)(this.__genericInstance)) {
            this.__genericInstance = new TSUniqueError('GenericSingletonError');
        }
        return this.__genericInstance;
    }
    static timeoutError() {
        if (!(0, commons_1.$ok)(this.__timeoutInstance)) {
            this.__timeoutInstance = new TSUniqueError('TimeoutSingletonError');
        }
        return this.__timeoutInstance;
    }
}
exports.TSUniqueError = TSUniqueError;
class TSError extends Error {
    constructor(message, infos) {
        super(message);
        this.infos = infos;
    }
}
exports.TSError = TSError;
function $subclassReponsabililty(instance, method) {
    throw new TSError(`implementation of method ${instance.constructor.name}.${method.name}() is subclasses reponsabillity.`, {
        object: instance,
        method: method
    });
}
exports.$subclassReponsabililty = $subclassReponsabililty;
class TSHttpError extends TSError {
    constructor(message, status, infos) {
        super(message, infos);
        this.status = status;
    }
}
exports.TSHttpError = TSHttpError;
//# sourceMappingURL=tserrors.js.map