import { Interval, TSRange } from "./tsrange";
import { TSDate } from "./tsdate";
import { Comparison, Nullable } from "./types";
import { TSCouple, TSCoupleConstructor } from "./tscouple";
/************************************************
 *  WARNING: range conformance methods and containing
 *  and intersectionning methods do round dates to minutes
 ************************************************/
export declare class TSInterval extends TSCouple<Nullable<TSDate>, Nullable<TSDate>> implements Interval {
    static make(a: Nullable<TSDate>, b: Nullable<TSDate>): TSInterval;
    get start(): TSDate;
    get end(): TSDate;
    clone(): TSInterval;
    get hasSignificantRange(): boolean;
    get isValid(): boolean;
    get isEmpty(): boolean;
    get range(): TSRange;
    daysInterval(): TSInterval;
    hasSameRange(other: TSInterval): boolean;
    containsDate(aDate: TSDate): boolean;
    intersects(other: TSInterval): boolean;
    contains(other: TSInterval): boolean;
    containedIn(other: TSInterval): boolean;
    continuousWith(other: TSInterval): boolean;
    compare(other: any): Comparison;
    isEqual(other: any): boolean;
    toJSON(): {
        start: Nullable<TSDate>;
        end: Nullable<TSDate>;
    };
    toArray(): TSInterval[];
}
export interface TSIntervalConstructor extends TSCoupleConstructor<Nullable<TSDate>, Nullable<TSDate>> {
    new (first: Nullable<TSDate>, second: Nullable<TSDate>): TSInterval;
}
